<?php
if (!isset($urnreg_path)) {
	require_once("../config.php");
}

class AuthManager {
	public static function getAuth($authModule = '') {
		GLOBAL $urnreg_path;
		
		if (strcmp($authModule, "")==0) {
			GLOBAL $AUTH_MODULE;
			$authModule = $AUTH_MODULE;
		}
		
		if (strcmp($authModule,"sSpAuth")==0) {
			require_once($urnreg_path."/AuthModules/sSpAuth.php");
			return new sSpAuth();
		}
		else if (strcmp($authModule,"LDAPAuth")==0) {
			require_once($urnreg_path."/AuthModules/LDAPAuth.php");
			return new LDAPAuth();
		}
		else if (strcmp($authModule,"PAPIAuth")==0) {
			require_once($urnreg_path."/AuthModules/PAPIAuth.php");
			return new PAPIAuth();
		}
		else {
			require_once($urnreg_path."/AuthModules/FakeAuth.php");
			return new FakeAuth();
		}
	}
	
	public static function getAuthConfig() {
		GLOBAL $AUTH_MODULE_CONFIG;
		
		if (isset($AUTH_MODULE_CONFIG)) {
			return $AUTH_MODULE_CONFIG;
		}
		else {
			return array();
		}
	}
}

?>
