<?php
if (!isset($urnreg_path)) {
	require_once("../../config.php");
}
else {
	GLOBAL $siledap_path;
}
require_once($siledap_path."/LdapConf.php");
require_once($siledap_path."/LdapManager.php");
require_once($urnreg_path."/Auth.php");
require_once($urnreg_path."/AuthManager.php");

class LDAPAuth implements Auth {
	private $config;

	public function __construct() {
		$this->config = AuthManager::getAuthConfig();
	}
	
	public function isAuth() {
		if (!isset($_SESSION)) {
			session_start();
		}
		if (!array_key_exists("auth",$_SESSION)) {
			$_SESSION["auth"] = false;
		}
		return $_SESSION["auth"];
	}

	public function doAuth($urlback = '') {
		GLOBAL $urnreg_path;
		
		if (!isset($_SESSION)) {
			session_start();
		}
		if (strcmp($urlback,"")!=0) {
			$_SESSION["lastUrlBack"] = $urlback;
		}
		else if (array_key_exists("lastUrlBack",$_SESSION)&&strcmp($_SESSION["lastUrlBack"],"")!=0) {
			$urlback = $_SESSION["lastUrlBack"];
		}
		
		if ($this->isAuth()) {
			header("Location: ".$urlback);
		}
		else {
			require_once($urnreg_path.$this->config["login-template"]);
		}
	}
	
	public function login($username,$password) {
		if (!isset($_SESSION)) {
			session_start();
		}

		$found = false;
	
		$lm=new LdapManager($this->config["ldap_server_name"],$this->config["ldap_server_port"]);
		$lm->setOption(LDAP_OPT_PROTOCOL_VERSION,3);
		$lm->connectLdap($this->config["ldap_user"],$this->config["ldap_pass"]);

		$filter="(".$this->config['user_attr_id']."=".$username.")";
		$entries=$lm->search($this->config["ldap_dn_base"],$filter,false);
		foreach ($entries as $entry) {
			if ($entry->hasAttribute($this->config["pass_attr_id"])) {
				$values = $entry->getAttribute($this->config["pass_attr_id"]);
				if (in_array($password,$values->getValues())) {
					$_SESSION["username"] = $username;
					$_SESSION["ldap_entry"] = $entry;
					$found = true;
				}
			}
		}
	
		if (!isset($_SESSION)) {
			session_start();
		}
		$_SESSION["auth"] = $found;
		return $found;
	}
	
	public function getUser() {
		if (!isset($_SESSION)) {
			session_start();
		}
		
		return $_SESSION["username"];
	}
	
	public function getAttributes() {
		if (!isset($_SESSION)) {
			session_start();
		}
		
		$res = array();
		
		$entryLdap = $_SESSION["ldap_entry"];
		$list_attrs = $this->config["attributes"];
		foreach ($list_attrs as $nameLdap => $nameIdP) {
			if ($entryLdap->hasAttribute($nameLdap)) {
				$values = $entryLdap->getAttribute($nameLdap);
				$res[$nameIdP] = $values->getValues();
			}
		}
		
		return $res;
	}
	
	public function doLogout() {
		if (!isset($_SESSION)) {
			session_start();
		}
		$_SESSION["auth"] = false;
		return !$this->isAuth();
	}
	
}

?>