<?php
if (!isset($urnreg_path)) {
	require_once("../../config.php");
}
require_once($urnreg_path."/Auth.php");
require_once($urnreg_path."/AuthManager.php");
require_once('PoA.php');

class PAPIAuth implements Auth {
	private $config;
	private $poa;
	private $userData;
	private $deniedAttributes;
	private $assertion;

	public function __construct() {
		$this->config = AuthManager::getAuthConfig();
		$this->poa = new PoA($this->config["poa_id"]);
		$this->userData = array();
		$this->deniedAttributes = array("PAPIAuthValue","PAPIASName","PAPIAssertion");
	}

	public function isAuth() {
		if (!isset($_SESSION)) {
			session_start();
		}
		if (array_key_exists("userData",$_SESSION)) {
			$this->userData = $_SESSION['userData'];
		}
		return strcmp($this->userData['PAPIAuthValue'],"1")==0;
	}
	
	public function doAuth($urlback = '') {
		if (!isset($_SESSION)) {
			session_start();
		}
		if (strcmp($urlback,"")!=0) {
			$_SESSION["lastUrlBack"] = $urlback;
		}
		else if (array_key_exists("lastUrlBack",$_SESSION)&&strcmp($_SESSION["lastUrlBack"],"")!=0) {
			$urlback = $_SESSION["lastUrlBack"];
		}

		error_log(print_r($this->poa->check_Access(),true));
		$this->userData = $this->poa->check_Access();
		$_SESSION["userData"] = $this->userData;
		$this->assertion = $this->userData['PAPIAssertion'];
		$_SESSION["assertion"] = $this->assertion;
		if ($this->isAuth()) {
			header("Location: ".$urlback);
		}
		else {
			return false;
		}
	}
	
	public function login($username,$password) {
		return true;
	}
	
	public function getUser() {
		if (!isset($_SESSION)) {
			session_start();
		}
		if (array_key_exists("userData",$_SESSION)) {
			$this->userData = $_SESSION['userData'];
		}
		return $this->userData[$this->config["user_attr_id"]];
	}
	
	public function getAttributes() {
		if (!isset($_SESSION)) {
			session_start();
		}
		if (array_key_exists("assertion",$_SESSION)) {
			$this->assertion = $_SESSION['assertion'];
		}
		$res = array();
		$dataAssertion = explode($this->config["sep_list_attr"],$this->assertion);
		foreach ($this->userData as $key => $value) {
			if (!in_array($key, $this->deniedAttributes)) {
				if (strpos($value,$this->config["sep_multivalues_attr"])===false) {
					$res[$key]=array($value);
				}
				else {
					$res[$key]=explode($this->config["sep_multivalues_attr"],$value);
				}
			}
		} 
		return $res;
	}
	
	public function doLogout() {
		if (!isset($_SESSION)) {
			session_start();
		}
		if (array_key_exists("assertion",$_SESSION)) {
			unset($_SESSION["assertion"]);
		}
		if (array_key_exists("userData",$_SESSION)) {
			unset($_SESSION["userData"]);
		}
	}
}

?>