<?php
if (!isset($urnreg_path)) {
	require_once("../config.php");
}
require_once($urnreg_path."/authr_config.php");
require_once($urnreg_path."/AuthManager.php");

class AuthREngine {
	private $policy;
	private $authModule;

	public function __construct() {
		GLOBAL $AUTHR_POLICY;
		
		$auth = AuthManager::getAuth();

		$this->policy = $AUTHR_POLICY;
		$this->authModule = $auth;
	}

	public function getAdmins($urnvalue) {
		$res = array();
	
		foreach ($this->policy as $namespace => $rules) {
			if ($this->isInside($urnvalue, $namespace)) {
				foreach ($rules as $rule) {
					$checkrules = $rule["policy"];
					if (!in_array($rule["email"], $res)) {
						$res[] = $rule["email"];
					}
				}
			}
		}
		
		return $res;
	}
	
	public function isAllowedToAdmin($urnvalue) {
		if ($this->authModule->isAuth()==false) {
			return false;
		}
		
		$attrs = $this->authModule->getAttributes();
		
		foreach ($this->policy as $namespace => $rules) {
			if ($this->isInside($urnvalue, $namespace)) {
				foreach ($rules as $rule) {
					$checkrules = $rule["policy"];
					$res = true;
					foreach ($checkrules as $nameAttr => $regExpAttr) {
						if (!array_key_exists($nameAttr, $attrs)) {
							$res = false;
						}
						else {
							$values = $attrs[$nameAttr];
							$res2 = false;
							foreach ($values as $avalue) {
								$temp = preg_match("/".$regExpAttr."/", $avalue);
								if ($temp==1) {
									$res2 = true;
								}
							}
							$res &= $res2;
						}
					}
					if ($res == true) {
						return $res;
					}
				}
			}
		}
		return false;
	}
	
	private function isInside($urn, $namespace) {
		$tU = explode(":",$urn);
		$tN = explode(":",$namespace);
		
		if (count($tN)>count($tU)) {
			return false;
		}
		for ($i=0; $i<count($tN); $i++) {
			if (strcmp($tN[$i],$tU[$i])!=0) {
				return false;
			}
		}
		return true;
	}
}	
		
?>