<?php
require_once("../../config.php");
require_once($urnreg_path."/AuthManager.php");

$auth = AuthManager::getAuth();
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html>
<head>
	<title>URNreg - API</title>
    <link href="css/urnreg.css" rel="stylesheet" type="text/css">
	<link rel="stylesheet" type="text/css" href="NiftyCube/niftyCorners.css">
	<link rel="stylesheet" type="text/css" href="SweetTitles/sweetTitles.css">
	<script type="text/javascript" src="Prototype/prototype.js"></script>
	<script type="text/javascript" src="NiftyCube/niftycube.js"></script>
	<script type="text/javascript" src="js/Base64.js"></script>
        <script type="text/javascript" src="js/URNregConfig.js"></script>
        <script type="text/javascript" src="js/urnregmanager.js"></script>
	<script type="text/javascript">
	</script>
</head>
<body>
<div id="main">
	<div id="header">
		<div id="headerthing">&nbsp;</div>
		<div id="headercontent">
			<div id="nav">
				<ul id="list">
<?php
if ($auth->isAuth()) {
?>
					<li style="float: right;">Logged as <?php echo $auth->getUser(); ?> - <a href="logout.php"><span>Logout</span></a></li>
<?php
}
else {
?>
					<li style="float: right;"><a href="login.php"><span>Login</span></a></li>
<?php
}
?>
					<li><a href="index.php"><span>Home</span></a></li>
					<li><a href="browser.php"><span>See URNs</span></a></li>
					<li><a href="browser-oid.php"><span>See OIDs</span></a></li>
					<li><a href="api.php"><span>API</span></a></li>
					<li><a href="admin.php"><span>Admin</span></a></li>
				</ul>
			</div>
		</div>
	</div>
	<div id="content">
<p>The browser of URNreg is using some REST-style web services for getting registered and delegated URNs.</p>
<h3>Getting an URN</h3>
<p>This web service is used for checking if an URN has been registered and, also, getting the registration information of it. You can specify if you want a simple HTML page with the information, the default mode, or you want an XML message.</p>
<p>The URL is:</p>
<pre>	<?php echo $API_URI_BASE; ?>/search/</pre>
<p>And the parameters are:</p>
<ul>
<li><strong>urn</strong>=URL-ESCAPED-URN: the requested URN in an escaped way.</li>
<li><strong>format=machine</strong>: put this parameter if an XML message is preferred instead an HTML response</li>
</ul>
<p>Some examples:</p>
<pre>	<?php echo $API_URI_BASE; ?>/search/?urn=urn%3Ageant%3Aedugain </pre>
<pre>	<?php echo $API_URI_BASE; ?>/search/?urn=urn%3Ageant%3Aedugain&format=machine </pre>
<p>An example of an XML response:</p>
<pre>&lt;Response&gt;
&nbsp;&nbsp;&nbsp;&lt;urn value="urn:geant:edugain:component:be"&gt;
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&lt;descriptions&gt;
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&lt;description value="This is the URN base for Bridging Elements"/&gt;
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&lt;/descriptions&gt;
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&lt;presentations&gt;
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&lt;presentation value="Elemento de Enlace" lang="es"/&gt;
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&lt;presentation value="Bridging Element" lang="en"/&gt;
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&lt;/presentations&gt;
&nbsp;&nbsp;&nbsp;&lt;/urn&gt;
&lt;/Response&gt;</pre>
<p>There is available an <a href="../search/schema.xs">XML schema</a> of the <strong>search web service</strong> describing its reponses.</p>
<h3>Getting the list of registered or delegated URNs</h3>
<p>This web service is used for getting the list of registered or delegated URNs in this service. You can specify if you want a simple HTML page with the information, the default mode, or you want an XML message.</p>
<p>The URL is:</p>
<pre>	<?php echo $API_URI_BASE; ?>/list/</pre>
<p>And the parameters are:</p>
<ul>
<li><strong>type</strong>=[ registered | delegated ]: when <i>registered</i> is used for getting the list of registered URNs, the default value, and <i>delegated</i> is used for getting the list of delegated URNs.</li>
<li><strong>format=machine</strong>: put this parameter if an XML message is preferred instead an HTML response</li>
</ul>
<p>Some examples of requests:</p>
<pre>	<?php echo $API_URI_BASE; ?>/list/ </pre>
<pre>	<?php echo $API_URI_BASE; ?>/list/?format=machine </pre>
<pre>	<?php echo $API_URI_BASE; ?>/list/?type=delegated&format=machine </pre>
<p>An example of an XML response from a registered list request:</p>
<pre>&lt;Response&gt;
&nbsp;&nbsp;&nbsp;&lt;urns&gt;
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&lt;urn value="urn:geant:edugain"&gt;
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&lt;descriptions&gt;
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&lt;description value="This is the root URN for eduGAIN components"/&gt;
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&lt;/descriptions&gt;
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&lt;/urn&gt;
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&lt;urn value="urn:geant:edugain:reference"&gt;
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&lt;descriptions&gt;
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&lt;description value="Namespace for identifiers of references to eduGAIN 
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;specific mechanisms inside SAML constructs"/&gt;
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&lt;/descriptions&gt;
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&lt;/urn&gt;
&nbsp;&nbsp;&nbsp;&lt;/urns&gt;
&lt;/Response&gt;</pre>
<p>You can read the <a href="../list/registered_schema.xs">XML schema</a> for registered URNs requests or the <a href="../list/delegated_schema.xs">XML schema</a> for delegated URNs requests.</p>
</div>
	<div id="footer"><img src="icons/siledap-api.png" alt="api" /></div>
</div>
</body>
</html>
