<?php
require_once("../../config.php");
require_once($urnreg_path."/common.php");
require_once($siledap_path."/LdapConf.php");
require_once($siledap_path."/LdapManager.php");


function searchURNEntry($lm,$urnvalue) {
	GLOBAL $URN_LDAP_BASE;
	GLOBAL $OID_LDAP_BASE;

	$searchBase = $URN_LDAP_BASE;
	if (strpos($urnvalue, "urn:oid:")!==FALSE && strpos($urnvalue, "urn:oid:")==0) {
		$searchBase = $OID_LDAP_BASE;
	}

	$selurn = "";
	$found = false;
	$searchurn = $urnvalue;
	while ($found==false&&strcmp($searchurn,"")!=0) {
		$filter="(urnRegValue=".$searchurn.")";
		$entries=$lm->search($searchBase,$filter);
		if (count($entries)==1) {
			$urn=$entries[0];
			$selurn=$urn;
			$found=true;
		}
		else {
			$temp = explode(":",$searchurn);
			array_pop($temp);
			$searchurn = implode(":",$temp);
		}
	}
	
	return $selurn;
}

function getURN($lm,$urnvalue) { 
	$res="";
	$urn=searchURNEntry($lm,$urnvalue);
	$objs=$urn->getObjectClassList()->getValues();
	if (in_array("urnRegDelegationStr",$objs)||in_array("urnRegDelegation",$objs)) {
		$wsEP=$urn->getSingleAttribute("urnRegHttpsURI");
		$res=getDelegatedURN($urnvalue,$wsEP);
	}
	else if (in_array("urnRegDescriptionStr",$objs)||in_array("urnRegDescription",$objs)) {
		$user = "";
		if ($urn->hasAttribute("seeAlso")) {
			$user = $lm->getEntry($urn->getSingleAttribute("seeAlso"));
		}
		$res=echoURNDescription($urn, $user);
	}
	return $res;
}


$lm=new LdapManager($LDAP_SERVER_NAME,$LDAP_SERVER_PORT);
$lm->setOption(LDAP_OPT_PROTOCOL_VERSION,3);
$lm->connectLdap($LDAP_USER,$LDAP_PASS);

$success=false;

$urnvalue = "";

if (array_key_exists('urn',$_REQUEST)) {
	$urnvalue=rawurldecode($_REQUEST['urn']);
	if (strpos($urnvalue,"urn:")===FALSE) {
		$urnvalue="urn:oid:".implode(":",explode(".",rawurldecode($urnvalue)));
	}
}
else if (array_key_exists('oid',$_REQUEST)) {
	$urnvalue="urn:oid:".implode(":",explode(".",rawurldecode($_REQUEST['oid'])));
}
if (strcmp($urnvalue,"")!=0) {
	$format='human';
	if (array_key_exists('format',$_REQUEST)) {
		$format=$_REQUEST['format'];
	}
	$urn=searchURNEntry($lm,$urnvalue);
	if (!is_string($urn)) {
    	if (strcmp($format,"machine")==0) {
			header('Content-type: text/xml');
			echo "<Response>";
			$urn=getURN($lm,$urnvalue);
			echo $urn;
			echo "</Response>";
		}
		else {
			$urn=getURN($lm,$urnvalue);
    		$xml = DOMDocument::loadXML($urn);
			$xsl = new DomDocument;
			$xsl->load('template.xslt');
			
			$proc = new XSLTProcessor;
			$proc->importStyleSheet($xsl);
			$proc->setParameter('','uri',$_SERVER['REQUEST_URI']);
			$proc->setParameter('','urixml',$_SERVER['REQUEST_URI']."&format=machine");
			echo($proc->transformToXML($xml));
		}
	}
	else {
		echo "<p>URN <strong>".$urnvalue."</strong> not found</p>";
	}
}
else {
	include_once("form.html");
}

?>