<?xml version="1.0"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:output method="html"/>
<xsl:param name="uri" select="defaultstring"/>
<xsl:param name="urixml" select="defaultstring"/>
<xsl:template match="description">
	<xsl:value-of select="@value"/>
</xsl:template>
<xsl:template match="presentation">
	<div><div class="leftcol">Presentation [<xsl:value-of select="@lang"/>]:</div><div class="rightcol"><xsl:value-of select="@value"/></div></div>
</xsl:template>
<xsl:template match="//object[@mode='oid']">
	<div><div class="leftcol">OID:</div><div class="rightcol"><font color="#990000"><xsl:value-of select="@value"/></font></div></div>
</xsl:template>
<xsl:template match="urn">
	<html xmlns="http://www.w3.org/1999/xhtml">
		<head>
			<meta http-equiv="content-type" content="text/html; charset=utf-8" />
			<style type="text/css">
    <![CDATA[
    
html, body { 
    font-family:verdana, arial, helvetica, sans-serif;
    font:11px/14px verdana, arial, helvetica, sans-serif;
    margin: 0;
    height:100%;
    color: white;
    background: #808080;
}

body div#main {
	margin: auto;
	height: 100%;
	width: 780px;
    background: #ffffff;
}

div#main div#header {
	background: #ECFFE6;
	background: #f7f7f7;
	border-bottom: 4px solid #ADC7A6;
}

div#main div#header div#headercontent {
	margin-left: 24px;
	background: url(logo-urnreg.png) no-repeat center left;
	position: relative;
	text-align: right;
	color: black;
	font-size: 18px;
	padding: 16px;
}

div#main div#header div#headerthing {
	height: 8px;
	background: #5F9410;
}

div#content {
	color: black;
	padding: 12px; 
}

div#urnbox {
	padding: 12px;
	background-color: #fafafa;
	position: relative;
}
 
div.leftcol {
	position: absolute;
	font-weight: bold;
}

div.rightcol {
	margin-left: 150px;
}

div#machine {
	padding-top: 8px;
	text-align: center;
}

	]]>
			</style>
			<title>URNreg - Search web service</title>
		</head>
		<body>
			<div id="main">
				<div id="header">
					<div id="headerthing"> </div>
					<div id="headercontent"><xsl:value-of select="@value"/></div>
				</div>
				<div id="content">
					<div id="urnbox" xmlns="">
						<div>
							<div class="leftcol">Namespace: </div>
							<div class="rightcol"><font color="#990000"><xsl:value-of select="@value"/></font></div>
						</div>
						<xsl:apply-templates select="//object[@mode='oid']"/>
						<div>
							<div class="leftcol">Description: </div>
							<div class="rightcol"><xsl:apply-templates select="//description"/></div>
						</div>
						<xsl:apply-templates select="//presentation"/>
						<div>
							<div class="leftcol">Reg. URL:  </div>
							<div class="rightcol"><a href="{$uri}"><xsl:value-of select="$uri"/></a></div>
						</div>
					</div>
					<div id="machine"><a href="{$urixml}">Show XML document</a></div>
				</div>
			</div>
		</body>
	</html>
</xsl:template>
</xsl:stylesheet>